# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# dataproxy.py
#  
# classes permettant de vérifier l'authentification sur différents supports
# (actuellement seulement annuaire LDAP)
#       
###########################################################################

# utile ?
class IAuthProxy:
    """Interface pour un système d'authentification et de récupération des infos utilisateurs.
    Mettre les éventuels commandes de connextion, ... dans __init__.py"""
       
    def get_data(self, identifier):
        """récupère les données correspondant à identifier
        
        @param identifier: à priori l'identifiant d'un utilisateur dans le système de données
        """

    def authenticate(self, login, password):
        """Vérifie la validité d'un couple login/password

        @param login: identifiant de l'utilisateur dans ce système
        @param password: mot de passe

        retourne True ou False 
        """
        # FIXME : utiliser cred et retourner un avatar ? 

import ldap

class LDAPProxy:
    """récupère les infos d'un utilisateur dans un annuaire LDAP"""
    __implements__ = (IAuthProxy,)

    def __init__(self, host, port=389):
        self.proxy = ldap.open(host,int(port))
        
    def authenticate(self, uid, passwd):
        search_string = 'o=gouv, c=fr'
        result = self.proxy.search_s(search_string, ldap.SCOPE_SUBTREE,'(uid=%s)' % uid)
        try:
            self.proxy.simple_bind_s(result[0][0], passwd)
        except Exception, e:
            success = False
        else:
            success = True
        # self.proxy.unbind_s()
        return success

    def get_data(self, uid):
        search_string = 'o=gouv, c=fr'
        result = self.proxy.search_s(search_string, ldap.SCOPE_SUBTREE, '(uid=%s)' % uid)
        # récupération des données 
        # FIXME : utiliser le compte utilisateur ou un compte anonyme ?
        try:
            return result[0][1]
        except:
            return {}
