# -*- coding: UTF-8 -*-
###########################################################################
#
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# libsecure.py
#
# classes utilitaires pour lancement des services en https
#
###########################################################################

import httplib, xmlrpclib
from OpenSSL import SSL
from os.path import join, dirname
from ConfigParser import ConfigParser

# transport sécurisé utilisant un certificat
class TransportEole(xmlrpclib.SafeTransport):
    
    def make_connection(self, host):
        # create a HTTPS connection object from a host descriptor
        # host may be a string, or a (host, x509-dict) tuple
        localhost, extra_headers, x509 = self.get_host_info(host)
        try:
            HTTPS = httplib.HTTPS
        except AttributeError:
            raise NotImplementedError(
                "your version of httplib doesn't support HTTPS"
                )
        else:
            cx = HTTPS(localhost, None,
                       key_file = join(dirname(__file__), 'certs/server.pem'),
                       cert_file = join(dirname(__file__), 'certs/server.pem'))
            return cx

        
class ServerContextFactory:
    """
    Factory permettant de créer un contexte SSL
    """

    def __init__(self,certfile=''):
        if certfile != '':
            self.certfile = certfile
        else:
            self.certfile = join(dirname(__file__), 'certs/server.pem')

    def getContext(self):
        """Create an SSL context.
        This is a sample implementation that loads a certificate from a file 
        called 'server.pem'."""
        ctx = SSL.Context(SSL.SSLv23_METHOD)
        ctx.use_certificate_file(self.certfile)
        ctx.use_privatekey_file(self.certfile)
        return ctx

