# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# config.py
#  
# fichier de configuration pour la librairie SSO Eole
#       
###########################################################################

import locale, os
from creole.parsedico import parse_dico

# dico local pour Eole1
dico = parse_dico()
ip_locale = dico['adresse_ip_eth0']

# durée de vie d'un ticket non utilisé : 10 minutes
SESSION_TIMER = 10 * 60
# durée de vie d'un ticket d'application : 20 secondes (utilisable une seule fois)
APP_TIMER = 60
# durée de vie d'un nombre magique permettant la communication entre un frontend et un backend
# ce timeout est reinitialise a chaque fois qu'une action est lancée
MAGIC_NUMBER_TIMEOUT =  60 * 5
# durée de vie des sessions expirées. Quand une session expire, on la garde dans un cache pour savoir
# si quand une session est non valide, si elle avait expirée ou si elle n'a jamais existée
EXPIRED_SESSION_TIMEOUT = 60 * 60 * 2
# infos sur le serveur ldap
LDAP_SERVER = ip_locale
LDAP_BASE = "o=gouv,c=fr"
# adresse du serveur d'authentification
AUTH_SERVER_ADDR= ip_locale
# port du serveur d'authentification
AUTH_SERVER_PORT= '8765'
# port de la page web d'authentification
AUTH_FORM_PORT = '8443'
# version de CAS (1 ou 2)
CAS_VERSION = 2
# URL de la page web d'authentification
AUTH_FORM_URL = 'https://%s:%s' % (AUTH_SERVER_ADDR, AUTH_FORM_PORT)
# URL du serveur d'authentification
AUTH_SERVER='https://%s:%s' % (AUTH_SERVER_ADDR, AUTH_SERVER_PORT)
# certificats ssl
CERTFILE = os.path.join(os.path.dirname(__file__),'certs/server.pem')
# encoding par défaut
encoding = locale.getpreferredencoding()
